SystemOrganization addCategory: #'Lumiere-Graphs'!

LCompositeShape subclass: #LGraphEdge
	instanceVariableNames: 'shape anotherShape origin destination length weight graph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Graphs'!

!LGraphEdge class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 10:57'!
between: shape and: anotherShape in: aLGraph
	| edge |
	edge := self new.
	edge between: shape and: anotherShape in: aLGraph.
	^ edge ! !

!LGraphEdge class methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 01:55'!
between: shape and: anotherShape origin: vector3D destination: anotherVector3D
	| edge |
	edge := self new.
	edge between: shape and: anotherShape origin: vector3D destination: anotherVector3D.
	^ edge ! !

!LGraphEdge methodsFor: 'accessing' stamp: 'FernandoOlivero 10/23/2009 11:39'!
between: aLShape and: anotherLShape in: aLGraph
	shape := aLShape .
	anotherShape := anotherLShape. 
	graph := aLGraph .
	graph
		addEdge: self ;
		associateShape: aLShape withEdge: self.
	self calculateLength.
		! !

!LGraphEdge methodsFor: 'accessing' stamp: 'FernandoOlivero 10/23/2009 03:38'!
between: aLShape and: anotherLShape origin: vector3D destination: anotherVector3D
	shape := aLShape .
	anotherShape := anotherLShape. 
	self origin: vector3D destination: anotherVector3D.! !

!LGraphEdge methodsFor: 'accessing' stamp: 'FernandoOlivero 10/24/2009 11:57'!
calculateLength
	| vx vy len |
	origin := self origin.
	destination := self destination .
	vx :=  origin first - destination first .
	vy := origin second  - destination second .
	length := (vx * vx + (vy * vy)) sqrt.
	length = 0 ifTrue: [length := 1.0e-4].
	! !

!LGraphEdge methodsFor: 'accessing' stamp: 'FernandoOlivero 10/23/2009 10:59'!
destination 
	^ graph locationOfChild: anotherShape .! !

!LGraphEdge methodsFor: 'accessing' stamp: 'FernandoOlivero 10/24/2009 11:59'!
destinationShape 
	^ anotherShape ! !

!LGraphEdge methodsFor: 'accessing' stamp: 'FernandoOlivero 10/23/2009 11:09'!
initialize 
	super initialize .
	weight := 0.! !

!LGraphEdge methodsFor: 'accessing' stamp: 'FernandoOlivero 10/23/2009 02:05'!
length 
	^ length ! !

!LGraphEdge methodsFor: 'accessing' stamp: 'FernandoOlivero 10/23/2009 10:59'!
origin
	^ graph locationOfChild: shape.! !

!LGraphEdge methodsFor: 'accessing' stamp: 'FernandoOlivero 10/23/2009 03:38'!
origin: vector3D destination: anotherVector3D
	origin :=  vector3D .
	destination := anotherVector3D .
	self calculateLength.! !

!LGraphEdge methodsFor: 'accessing' stamp: 'FernandoOlivero 10/24/2009 11:59'!
originShape
	^ shape! !

!LGraphEdge methodsFor: 'accessing' stamp: 'FernandoOlivero 10/24/2009 11:58'!
translationForcedBy: forceMagnitud
	| vx vy len dx f dy  |
	vx := origin first  - destination first .
	vy := origin second - destination second.
	dx := forceMagnitud * vx.
	dy := forceMagnitud * vy.
	^ {dx. dy }! !

!LGraphEdge methodsFor: 'accessing' stamp: 'FernandoOlivero 10/23/2009 02:44'!
weight 
	^ weight! !

!LGraphEdge methodsFor: 'accessing' stamp: 'FernandoOlivero 10/23/2009 02:44'!
weight: magnitud 
	weight := magnitud ! !

LCompositeShape subclass: #LGraphOfShapes
	instanceVariableNames: 'edges showEdges shapeEdges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Graphs'!

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 11:06'!
addEdge: aLGraphEdge
	edges add: aLGraphEdge ! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 11:46'!
addEdgeBetween: shape and: anotherShape 
	self addEdgeBetween: shape and: anotherShape weight: 0.

	! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 11:45'!
addEdgeBetween: shape and: anotherShape weight: weight
	| edge |
	edge := LGraphEdge
		between: shape
		and: anotherShape
		in: self.
	edge weight: weight.
	^ edge 	! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 11:13'!
asGroupNode 
	| groupNode |
	groupNode := super asGroupNode.
	showEdges ifTrue:[ groupNode addChild: self edgesShapesGroupNode ].
	^ groupNode ! !

!LGraphOfShapes methodsFor: 'private' stamp: 'FernandoOlivero 10/23/2009 11:07'!
associateShape: aLShape withEdge: edge
	|edgesOfShape|
	edgesOfShape  :=  shapeEdges at: aLShape ifAbsentPut:[OrderedCollection new].
	edgesOfShape add: edge . ! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/22/2009 22:42'!
edges
	^ edges ! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 11:03'!
edgesOf: aLShape
	^ shapeEdges at: aLShape! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 11:55'!
edgesShapesGroupNode 
	| composite |
	composite := LCompositeShape new.
	edges do:[:edge|
		|line|
		line := LShape line.
		line
			scale:{ edge origin. edge destination. 2.0. };
			color: Color yellow.
		composite addChild: line ].
	^ composite asNode.! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 11:41'!
initialize 
	super initialize .
	showEdges := true.
	shapeEdges := Dictionary new.
	edges := OrderedCollection new.! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 12:15'!
lengthBetween: shape and: anotherShape
	| vDiff |
	vDiff := self velocityDiferenceBetween: shape and: anotherShape .
	^ vDiff first  squared + vDiff second squared.! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 12:13'!
maximumEdgeWeight
	edges isEmpty
		ifTrue:[ ^  0 ]
		ifFalse:[ ^ (edges sortBy:[:a :b| a weight >= b weight ]) first weight  ]
		
	! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 12:13'!
minimumEdgeWeight
	edges isEmpty
		ifTrue:[ ^  0 ]
		ifFalse:[ ^ (edges sortBy:[:a :b| a weight <= b weight ]) first weight  ]
		
	! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 02:49'!
nodesDo:block
	children do: block! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/22/2009 21:36'!
showEdges: aBoolean
	showEdges := aBoolean
	! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/23/2009 11:03'!
translate: aLShape by: translation
	| location |
	location := self locationOfChild: aLShape .
	childrenLocations at: aLShape put: location + translation.
	(self edgesOf: aLShape) do:[:edge| edge calculateLength ]. ! !

!LGraphOfShapes methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 10/24/2009 12:00'!
velocityDiferenceBetween: shape and: anotherShape 
	| origin destination vx vy |
	origin := self locationOfChild: shape.
	destination := self locationOfChild: shape.
	vx := origin first  - destination first.
	vy := origin second - destination second.
	^ { vx. vy }! !

!LumiereExamples methodsFor: '*Lumiere-Graphs' stamp: 'FernandoOlivero 10/23/2009 12:03'!
testLumiereGraphExample
	"
	self run:#testLumiereGraphExample
	"
	| maxI graph random morph |
	maxI := 15.
	graph := LGraphOfShapes new.
	random := Random new.
	20 timesRepeat:[
			|location shape|
			shape := LShape random.
			shape color: Color random.
			location := {random nextInt: maxI. random nextInt: maxI. random nextInt: maxI }.
			graph addChild: shape at: location ].
	1 to: 20 do:[:i|
		| originShape destinationShape | 
		originShape := graph children at: i.
		destinationShape := graph children atRandom: random. 
		graph addEdgeBetween: originShape and: destinationShape ].
	morph :=  graph openAsMorph.
	morph
		backgroundColor: Color white;
		update.	
	! !

!LumiereExamples methodsFor: '*Lumiere-Graphs' stamp: 'FernandoOlivero 10/24/2009 12:30'!
testLumiereGraphWithSpringEmbbederAnimationExample
	"
	self run:#testLumiereGraphWithSpringEmbbederAnimationExample
	"
	| edgeWeight maxI graph random layout morph randomWeight animation embedder |
	maxI := 15.
	edgeWeight := 2.
	graph := LGraphOfShapes new.
	random := Random new.
	randomWeight := Random new.
	20 timesRepeat: 
		[ | location shape |
		shape := LShape random.
		shape color: Color random.
		location := { 
			(random nextInt: maxI).
			(random nextInt: maxI).
			(random nextInt: maxI)
		 }.
		graph 
			addChild: shape
			at: location ].
	1 
		to: 20
		do: 
			[ :i | 
			| originShape destinationShape |
			originShape := graph children at: i.
			destinationShape := graph children atRandom: random.
			edgeWeight := randomWeight nextInt: 10.
			graph 
				addEdgeBetween: originShape
				and: destinationShape
				weight: edgeWeight ].
	morph :=  graph openAsMorph.
	morph
		placeCameraAt: {0. 0. 130} lookingAt: {0. 0. 0};
		backgroundColor: Color white;
		extent: 400@400.	
	embedder := L2DSpringEmbedderLayout new.
	embedder 
		numberOfIterations: 10;
		repulsionRadius: 40;
		idealEdgeLength: 40 ;
		maximumSpringOffset: 1.		
	animation := L2DSpringEmbedderAnimation  new.
	animation
		graph: graph ;
		embedder: embedder ;
		lumiereMorph: morph;
		run.
	! !

!LumiereExamples methodsFor: '*Lumiere-Graphs' stamp: 'FernandoOlivero 10/24/2009 12:03'!
testLumiereGraphWithSpringEmbbederExample
	"
	self run:#testLumiereGraphWithSpringEmbbederExample
	"
	| edgeWeight maxI graph random layout morph randomWeight |
	maxI := 15.
	edgeWeight := 2.
	graph := LGraphOfShapes new.
	random := Random new.
	randomWeight := Random new.
	20 timesRepeat: 
		[ | location shape |
		shape := LShape random.
		shape color: Color random.
		location := { 
			(random nextInt: maxI).
			(random nextInt: maxI).
			(random nextInt: maxI)
		 }.
		graph 
			addChild: shape
			at: location ].
	1 
		to: 20
		do: 
			[ :i | 
			| originShape destinationShape |
			originShape := graph children at: i.
			destinationShape := graph children atRandom: random.
			edgeWeight := randomWeight nextInt: 10.
			graph 
				addEdgeBetween: originShape
				and: destinationShape
				weight: edgeWeight ].
	layout := L2DSpringEmbedderLayout new.
	layout
		numberOfIterations: 10;
		repulsionRadius: 20;
		idealEdgeLength: 20 ;
		maximumSpringOffset: 1;
		graph: graph;
		run.
	morph :=  graph openAsMorph.
	morph
		backgroundColor: Color white;
		update.	
	! !

Object subclass: #L2DSpringEmbedderAnimation
	instanceVariableNames: 'embedder graph lumiereMorph delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Graphs'!

!L2DSpringEmbedderAnimation methodsFor: 'accessing' stamp: 'FernandoOlivero 10/24/2009 12:10'!
embedder
	^ embedder! !

!L2DSpringEmbedderAnimation methodsFor: 'accessing' stamp: 'FernandoOlivero 10/24/2009 12:10'!
embedder: anObject
	embedder := anObject! !

!L2DSpringEmbedderAnimation methodsFor: 'accessing' stamp: 'FernandoOlivero 10/24/2009 12:10'!
graph
	^ graph! !

!L2DSpringEmbedderAnimation methodsFor: 'accessing' stamp: 'FernandoOlivero 10/24/2009 12:11'!
graph: anObject
	graph := anObject
! !

!L2DSpringEmbedderAnimation methodsFor: 'initialize-release' stamp: 'FernandoOlivero 10/24/2009 12:26'!
initialize 
	super initialize .
	delay := Delay forSeconds: 0.5.! !

!L2DSpringEmbedderAnimation methodsFor: 'accessing' stamp: 'FernandoOlivero 10/24/2009 12:17'!
lumiereMorph: aLumiereMorph
	lumiereMorph := aLumiereMorph! !

!L2DSpringEmbedderAnimation methodsFor: 'running' stamp: 'FernandoOlivero 10/24/2009 12:25'!
run
	embedder graph: graph.
	embedder reset.
	lumiereMorph microworld: graph asMicroworld ;update.
	embedder numberOfIterations timesRepeat: [
		delay wait.
		embedder step.
		lumiereMorph
			microworld: graph asMicroworld;
			update ]! !

Object subclass: #L2DSpringEmbedderLayout
	instanceVariableNames: 'graph numberOfIterations repulsionRadius idealEdgeLength maximumSpringOffset edgeWeightRatio edgeWeightThreshhold deltas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Lumiere-Graphs'!

!L2DSpringEmbedderLayout methodsFor: 'private' stamp: 'FernandoOlivero 10/24/2009 11:58'!
addToDeltaOf: aLShape dx: dx dy: dy
	| translations |
	translations := deltas at: aLShape ifAbsentPut:[{0. 0}].
	translations at: 1 put: translations first + dx .
	translations at: 2 put: translations second + dy .
	! !

!L2DSpringEmbedderLayout methodsFor: 'private' stamp: 'FernandoOlivero 10/23/2009 10:44'!
applyDeltaTranslationTo: aLShape
	| delta |
	delta := self deltaOf: aLShape .
	graph translate: aLShape by: delta , {0}.
	deltas at: aLShape put: delta / 2.
	! !

!L2DSpringEmbedderLayout methodsFor: 'private' stamp: 'FernandoOlivero 10/23/2009 03:36'!
assignNextLengthToEdge: edge  
	|len idealTemp forceOfSpring translation |
	len := edge length .
	idealTemp := self idealEdgeLength - (edge weight * edgeWeightRatio).
	"the weight on the edge makes the edge ideally shorter"
	idealTemp < 0 ifTrue: [ idealTemp := 1 ].
	forceOfSpring := (idealTemp - len) / (len * 3). 	
	translation := edge translationForcedBy: forceOfSpring.
	self
		addToDeltaOf: edge originShape
			dx: translation first 
			dy: translation second; 
		addToDeltaOf: edge destinationShape
			dx: translation first negated 
			dy: translation second negated . 
	
	! !

!L2DSpringEmbedderLayout methodsFor: 'private' stamp: 'FernandoOlivero 10/23/2009 12:14'!
assignNextLengthToEdges
	| relevant |
	relevant := graph edges select:[:edge| edge weight > edgeWeightThreshhold ]. 
	relevant do:[:edge| self assignNextLengthToEdge: edge  ]! !

!L2DSpringEmbedderLayout methodsFor: 'private' stamp: 'FernandoOlivero 10/22/2009 22:21'!
computeEdgeWeightRatio
	| minWeight maxWeight distance |
	distance :=  graph maximumEdgeWeight - graph minimumEdgeWeight .
	distance isZero ifTrue: [ distance := 1 ].
	edgeWeightRatio := 90 / distance.! !

!L2DSpringEmbedderLayout methodsFor: 'private' stamp: 'FernandoOlivero 10/23/2009 12:15'!
computeNextPositionOfShape: aLShape 
	| widthMetricValue dx dy dlen delta|
	dx := 0.
	dy := 0.
	widthMetricValue := 0.
	graph nodesDo:[:node | 
		|length|
		length := graph lengthBetween: aLShape and: node .
		( (node = aLShape) not and:[ length isZero ] )
			ifTrue: [ 
				dx := dx + 0.001.
				dy := dy + 0.001].
		((node = aLShape) not and:[ length isZero not] and:[ 
			length < (repulsionRadius + widthMetricValue) squared ])
				ifTrue:[
					|vDif|
					vDif := graph velocityDiferenceBetween: aLShape and: node. 
					vDif := vDif / length.
					dx := dx + vDif x .	
					dy := dy + vDif y ]].
		
	dlen := dx squared + dy squared.
	dlen > 0 ifFalse: [^self].
	dlen := dlen sqrt / 2.
	self
		addToDeltaOf: aLShape dx: dx/dlen  dy: dy/dlen;
		applyDeltaTranslationTo: aLShape
	! !

!L2DSpringEmbedderLayout methodsFor: 'private' stamp: 'FernandoOlivero 10/23/2009 02:47'!
computeNextPositionOfShapes
	graph nodesDo:[:node| self computeNextPositionOfShape: node ].! !

!L2DSpringEmbedderLayout methodsFor: 'private' stamp: 'FernandoOlivero 10/23/2009 10:40'!
deltaOf: aLShape
	^ deltas at: aLShape ifAbsent:[{0. 0}].! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:12'!
edgeWeightRatio
	^ edgeWeightRatio! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:12'!
edgeWeightRatio: anObject
	edgeWeightRatio := anObject! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:39'!
edgeWeightThreshhold
	^ edgeWeightThreshhold! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:39'!
edgeWeightThreshhold: anObject
	edgeWeightThreshhold := anObject! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:12'!
graph
	^ graph! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:27'!
graph: anObject
	graph := anObject.
	self computeEdgeWeightRatio ! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:12'!
idealEdgeLength
	^ idealEdgeLength! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:12'!
idealEdgeLength: anObject
	idealEdgeLength := anObject! !

!L2DSpringEmbedderLayout methodsFor: 'initialize-release' stamp: 'FernandoOlivero 10/22/2009 22:13'!
initialize
	super initialize.
	self initializeSpringEmbedder ! !

!L2DSpringEmbedderLayout methodsFor: 'initialize-release' stamp: 'FernandoOlivero 10/23/2009 12:18'!
initializeSpringEmbedder
	numberOfIterations := 10.
	repulsionRadius := 5.
	idealEdgeLength := 5.
	maximumSpringOffset := 1.
	edgeWeightThreshhold := 0.	! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:12'!
maximumSpringOffset
	^ maximumSpringOffset! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:12'!
maximumSpringOffset: anObject
	maximumSpringOffset := anObject! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:12'!
numberOfIterations
	^ numberOfIterations! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:12'!
numberOfIterations: anObject
	numberOfIterations := anObject! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:12'!
repulsionRadius
	^ repulsionRadius! !

!L2DSpringEmbedderLayout methodsFor: 'accessing' stamp: 'FernandoOlivero 10/22/2009 22:12'!
repulsionRadius: anObject
	repulsionRadius := anObject! !

!L2DSpringEmbedderLayout methodsFor: 'running' stamp: 'FernandoOlivero 10/24/2009 12:19'!
reset
	deltas := Dictionary new.! !

!L2DSpringEmbedderLayout methodsFor: 'running' stamp: 'FernandoOlivero 10/24/2009 12:19'!
run
	self reset.
	numberOfIterations timesRepeat: [ self step ].! !

!L2DSpringEmbedderLayout methodsFor: 'private' stamp: 'FernandoOlivero 10/23/2009 10:40'!
step
	self assignNextLengthToEdges.
	self computeNextPositionOfShapes! !
